<template>
  <single-pane capt="Услуги">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      :ref="dataGridRefName"
    />

    <ob-modal
      ref="viewItem"
      custom-class="modal-medium"
      :titleSecond = "'Добавление'"
      :title="'Услуга'"
      :is-show-controls="false"
    >
      <view-service
        :service-types="activites"
        :selected-data="selectedData"
        :data-source="selectedData"
        :disabledForm="disabledForm"
        :isShowControls="false"
        :resourceTypeStream="resourceTypeStream"
        :key="Date.now()"
        @delete="onDelete"
        @submit="onSave" 
        ref="view-service"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import { SERVICE_GEOGRAPHY } from '@/resources/enum'
import SERVICES_MIXIN        from '@/mixins/enum/services'
import paging                from '@/mixins/dictionaries/paging';
import itemMixin             from '@/mixins/dictionaries/edit-item';
import SinglePane            from 'common-components/src/obComponents/obSinglePanels';
import ViewService           from './modal/viewService';
import ObModal               from 'common-components/src/obComponents/obModal';
import ObTable               from 'common-components/src/obComponents/obTable'
import ResourceTypeStream    from '@/pages/resourceTypesPage/resourceTypeStream';

export default {
  name: 'Services',
  components: {
    ObModal,
    ObTable,
    ViewService,
    SinglePane,
  },
  mixins: [
    paging,
    itemMixin,
    SERVICES_MIXIN
  ],
  data() {
    return {
      newStatus: false,
      selectedData: {},
      serviceTypes: [],
      activites: [],
      resourceList: [],
      resourceTypeStream: undefined,
      dataGridRefName: 'Services',
      api: {
          source: '/oboz2-dictionary-services-crud/v1/'
      },
    }
  },
  async mounted() {
    this.resourceTypeStream = new ResourceTypeStream();
    this.resourceList = await this.resourceTypeStream.getResources();
    this.masks = this.resourceTypeStream.getMasks()
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: 'Тип услуги',
          key: 'serviceTypeTitle',
          sortOrder: 'asc'
        },
        {
          title: 'География',
          key: 'geography',
          html: (data) => SERVICE_GEOGRAPHY[data.geography]
        },
        {
          title: 'Вид ресурса',
          key: 'resourceSpeciesTitle',
        },
        {
          title: 'Характеристика ресурса',
          key: 'resourceTypeUuid',
          html: ({resourceTypeUuid, mask}) => {
            if (resourceTypeUuid) {
              const params = this.resourceTypeStream.types.find(key => key.uuid === resourceTypeUuid);
              const title = params?.resourceSubTypeDTO?.title ?? '-';
              const parameter = params?.resourcePatternDTO ?? '-';
              let _mask = mask;
              for (let key in parameter.parameters) {
                _mask = _mask.replace(key, parameter.parameters[key]);
              }
              return title + ' / ' + _mask;
            } else {
              return ''
            }
          }
        },
        {
          title: 'Возможные ед. измерения',
          key: 'serviceUnitTitles',
          html: ({serviceUnitTitles}) => {
            return serviceUnitTitles[0];
          },
        },
        {
          title: 'Статус',
          key: 'is_active',
          width: 'auto',
          html: (data) => data.isActive ? 'Активна' : 'Неактивна'
        }
      ]
    },
    disabledForm() {
      return !this.newStatus;
    },
    activeServiceType() {
      const _type = this.serviceTypes.find(type => {
        return type.uuid === this.selectedData.serviceTypeUuid
      });

      return _type || {};
    }
  }
}
</script>